# include/fluidsynth/gen.h File Reference

Go to the source code of this file.

## Data Structures

struct | fluid_gen_t
| SoundFont generator structure. More...

## Enumerations

enum

fluid_gen_type {
GEN_STARTADDROFS, GEN_ENDADDROFS, GEN_STARTLOOPADDROFS, GEN_ENDLOOPADDROFS,
GEN_STARTADDRCOARSEOFS, GEN_MODLFOTOPITCH, GEN_VIBLFOTOPITCH, GEN_MODENVTOPITCH,
GEN_FILTERFC, GEN_FILTERQ, GEN_MODLFOTOFILTERFC, GEN_MODENVTOFILTERFC,
GEN_ENDADDRCOARSEOFS, GEN_MODLFOTOVOL, GEN_UNUSED1, GEN_CHORUSSEND,
GEN_REVERBSEND, GEN_PAN, GEN_UNUSED2, GEN_UNUSED3,
GEN_UNUSED4, GEN_MODLFODELAY, GEN_MODLFOFREQ, GEN_VIBLFODELAY,
GEN_VIBLFOFREQ, GEN_MODENVDELAY, GEN_MODENVATTACK, GEN_MODENVHOLD,
GEN_MODENVDECAY, GEN_MODENVSUSTAIN, GEN_MODENVRELEASE, GEN_KEYTOMODENVHOLD,
GEN_KEYTOMODENVDECAY, GEN_VOLENVDELAY, GEN_VOLENVATTACK, GEN_VOLENVHOLD,
GEN_VOLENVDECAY, GEN_VOLENVSUSTAIN, GEN_VOLENVRELEASE, GEN_KEYTOVOLENVHOLD,
GEN_KEYTOVOLENVDECAY, GEN_INSTRUMENT, GEN_RESERVED1, GEN_KEYRANGE,
GEN_VELRANGE, GEN_STARTLOOPADDRCOARSEOFS, GEN_KEYNUM, GEN_VELOCITY,
GEN_ATTENUATION, GEN_RESERVED2, GEN_ENDLOOPADDRCOARSEOFS, GEN_COARSETUNE,
GEN_FINETUNE, GEN_SAMPLEID, GEN_SAMPLEMODE, GEN_RESERVED3,
GEN_SCALETUNE, GEN_EXCLUSIVECLASS, GEN_OVERRIDEROOTKEY, GEN_PITCH,
GEN_LAST
}

| Generator (effect) numbers (Soundfont 2.01 specifications section 8.1.3). More...
enum | fluid_gen_flags { GEN_UNUSED, GEN_SET, GEN_ABS_NRPN }
| Enum value for 'flags' field of _fluid_gen_t (not really flags). More...

## Functions

FLUIDSYNTH_API int | fluid_gen_set_default_values (fluid_gen_t *gen)
| Set an array of generators to their default values.

## Detailed Description

Functions and defines for SoundFont generator effects.

Definition in file gen.h.

## Enumeration Type Documentation

enum fluid_gen_type

Generator (effect) numbers (Soundfont 2.01 specifications section 8.1.3).

Enumerator:

  GEN_STARTADDROFS | Sample start address offset (0-32767).
  GEN_ENDADDROFS | Sample end address offset (-32767-0).
  GEN_STARTLOOPADDROFS | Sample loop start address offset (-32767-32767).
  GEN_ENDLOOPADDROFS | Sample loop end address offset (-32767-32767).
  GEN_STARTADDRCOARSEOFS | Sample start address coarse offset (X 32768).
  GEN_MODLFOTOPITCH | Modulation LFO to pitch.
  GEN_VIBLFOTOPITCH | Vibrato LFO to pitch.
  GEN_MODENVTOPITCH | Modulation envelope to pitch.
  GEN_FILTERFC | Filter cutoff.
  GEN_FILTERQ | Filter Q.
  GEN_MODLFOTOFILTERFC | Modulation LFO to filter cutoff.
  GEN_MODENVTOFILTERFC | Modulation envelope to filter cutoff.
  GEN_ENDADDRCOARSEOFS | Sample end address coarse offset (X 32768).
  GEN_MODLFOTOVOL | Modulation LFO to volume.
  GEN_UNUSED1 | Unused.
  GEN_CHORUSSEND | Chorus send amount.
  GEN_REVERBSEND | Reverb send amount.
  GEN_PAN | Stereo panning.
  GEN_UNUSED2 | Unused.
  GEN_UNUSED3 | Unused.
  GEN_UNUSED4 | Unused.
  GEN_MODLFODELAY | Modulation LFO delay.
  GEN_MODLFOFREQ | Modulation LFO frequency.
  GEN_VIBLFODELAY | Vibrato LFO delay.
  GEN_VIBLFOFREQ | Vibrato LFO frequency.
  GEN_MODENVDELAY | Modulation envelope delay.
  GEN_MODENVATTACK | Modulation envelope attack.
  GEN_MODENVHOLD | Modulation envelope hold.
  GEN_MODENVDECAY | Modulation envelope decay.
  GEN_MODENVSUSTAIN | Modulation envelope sustain.
  GEN_MODENVRELEASE | Modulation envelope release.
  GEN_KEYTOMODENVHOLD | Key to modulation envelope hold.
  GEN_KEYTOMODENVDECAY | Key to modulation envelope decay.
  GEN_VOLENVDELAY | Volume envelope delay.
  GEN_VOLENVATTACK | Volume envelope attack.
  GEN_VOLENVHOLD | Volume envelope hold.
  GEN_VOLENVDECAY | Volume envelope decay.
  GEN_VOLENVSUSTAIN | Volume envelope sustain.
  GEN_VOLENVRELEASE | Volume envelope release.
  GEN_KEYTOVOLENVHOLD | Key to volume envelope hold.
  GEN_KEYTOVOLENVDECAY | Key to volume envelope decay.
  GEN_INSTRUMENT | Instrument ID (shouldn't be set by user).
  GEN_RESERVED1 | Reserved.
  GEN_KEYRANGE | MIDI note range.
  GEN_VELRANGE | MIDI velocity range.
  GEN_STARTLOOPADDRCOARSEOFS | Sample start loop address coarse offset (X 32768).
  GEN_KEYNUM | Fixed MIDI note number.
  GEN_VELOCITY | Fixed MIDI velocity value.
  GEN_ATTENUATION | Initial volume attenuation.
  GEN_RESERVED2 | Reserved.
  GEN_ENDLOOPADDRCOARSEOFS | Sample end loop address coarse offset (X 32768).
  GEN_COARSETUNE | Coarse tuning.
  GEN_FINETUNE | Fine tuning.
  GEN_SAMPLEID | Sample ID (shouldn't be set by user).
  GEN_SAMPLEMODE | Sample mode flags.
  GEN_RESERVED3 | Reserved.
  GEN_SCALETUNE | Scale tuning.
  GEN_EXCLUSIVECLASS | Exclusive class number.
  GEN_OVERRIDEROOTKEY | Sample root note override.
  GEN_PITCH | Pitch (NOTE: Not a real SoundFont generator).
  GEN_LAST | Value defines the count of generators (fluid_gen_type).

Definition at line 36 of file gen.h.

enum fluid_gen_flags

Enum value for 'flags' field of _fluid_gen_t (not really flags).

Enumerator:

  GEN_UNUSED | Generator value is not set.
  GEN_SET | Generator value is set.
  GEN_ABS_NRPN | DOCME.

Definition at line 120 of file gen.h.

## Function Documentation

FLUIDSYNTH_API int fluid_gen_set_default_values | ( | fluid_gen_t * | gen | ) |

Set an array of generators to their default values.

Parameters:

  | gen | Array of generators (should be GEN_LAST in size).

Returns:
  Always returns 0

Definition at line 98 of file fluid_gen.c.

References fluid_gen_t::flags, fluid_gen_set_default_values(), GEN_LAST, GEN_UNUSED, fluid_gen_t::mod, fluid_gen_t::nrpn, and fluid_gen_t::val.

Referenced by fluid_gen_set_default_values().